Subject: Re: bug#78543: 29.2; checkdoc misses some CL (cl-lib) constructs.

From: Eli Zaretskii <[email-masked]>
Date: Sat, 31 May 2025 19:20:58 +0300

> From: Stefan Monnier <[email-masked]>
> Cc: Marco Antoniotti <[email-masked]>,  [email-masked]
> Date: Sat, 31 May 2025 10:56:19 -0400
> 
> >> ```
> >> (cl-defun funky-keys (&key ((:this that) 42) &aux (the-beast 666))
> >>     "Do something with THAT (passed via :THIS)"
> >>     ...
> >>     )
> >> ```
> 
> FWIW, I consider this `(:this that)` of CL's keyword args to be
> a misfeature, so I'm happy for Emacs to behave suboptimally here, tho
> I'd prefer for cl-lib to stop supporting it.

But do you have anything against the patch I proposed to install?

> > Also, I believe that THE-BEAST should
> > indeed be mentioned in the doc string.
> 
> Why?  It's not part of the function's exposed interface.
> It's just a weird way to define a local variable.
> 
> I also find this `&aux` thingy to be a misfeature in CL, which we
> usually shouldn't support [ tho currently it's admittedly handy at
> times in `cl-defstruct` constructors.  ], so I'm not sure it's worth
> complicating checkdoc for it.

I didn't suggest complicating checkdoc due to &aux arguments.  So we
basically agree here.